<?php declare(strict_types=1);

namespace Aviat\Kilo\Enum;

use Aviat\Kilo\Traits;
use JsonSerializable;

/**
 * Enum representing various control keys
 */
enum KeyType implements JsonSerializable {
	use Traits\EnumTrait;
	use Traits\ConstList;

	// ------------------------------------------------------------------------
	// Movement Keys
	// ------------------------------------------------------------------------
	case ArrowUp;
	case ArrowDown;
	case ArrowLeft;
	case ArrowRight;
	case Home;
	case End;
	case PageUp;
	case PageDown;
	// ------------------------------------------------------------------------
	// Editing Keys
	// ------------------------------------------------------------------------
	case Backspace;
	case Delete;
	case Enter;
	// ------------------------------------------------------------------------
	// Others
	// ------------------------------------------------------------------------
	case Escape;
}